import sys
import csv

dep_in = sys.argv[1]   #enter depth infile
res_in = int(sys.argv[2])   #enter resolution
gme_len = int(sys.argv[3])  #enter replicon length
sum_co = int(sys.argv[4])   #enter cutoff above which depth sums will be included

dep_file = open(dep_in, 'r')
dep_reader = csv.reader(dep_file, delimiter='\t')
#uncomment next four lines to start from dep files
dep_list = [0]*gme_len
for a in dep_reader:
    for aa in range(int(a[1]), int(a[2])):
        dep_list[aa] += int(a[3])

#uncomment next two lines to start from newline separated coverage files
#dep_list = dep_file.read().splitlines()
#dep_list = [int(x) for x in dep_list]

#print dep_list[0:100]

print "dep_list created"
sum_list = [0]*(gme_len+res_in-1)  #slightly longer than dep_list to account for summation

for b in range(len(dep_list)):
    sum_list[b] = sum(dep_list[b:(b+res_in)])

print "sum_list created"
#print sum_list[0:1000]
for c in range(len(sum_list)):
    if sum_list[c] <= sum_co:
        sum_list[c] = 0

print "sum_list stripped"
tss_list = []
num_list = []
stdv_list = []
sel_sum_list = []
zero_count = 0
d = 0
tss = 0
num = 0
#print sum_list[0:150]
while d < gme_len:
#    print "1d" + str(d)
    if sum_list[d] != 0 and sum_list[d+1] <= sum_list[d]:
        pc = 0.0
        stdv_num = 0.0
        stdv_den = 0.0
        zero_count = 0.0
        for dd in range(0, res_in):
#            print "dd" + str(dd)
            pc += dep_list[d+dd]*(d+dd)
            stdv_num += (dep_list[d+dd])*((dd+1-float(res_in)/2+1) ** 2)
            stdv_den += dep_list[d+dd]
            if dep_list[d+dd] == 0:
                zero_count += 0
#            print d
#            print dd
#            print stdv_num
#            print stdv_den
        num = sum(dep_list[d:d+res_in])
        tss = pc/num
        tss_list.append(tss)
        num_list.append(num)
        norm_f = (float(res_in) - zero_count - 1) / (float(res_in) - zero_count)
        stdv_list.append((stdv_num / (norm_f * stdv_den)) ** (0.5))
        sel_sum_list.append(sum_list[d])
        while sum_list[d+1] <= sum_list[d] and sum_list[d+1] != 0:
            d += 1
#            print "2d" + str(d)
    d += 1

fin_tss_list = []
f = 0
#while f < len(tss_list)-1:
#    if (tss_list[f+1]-tss_list[f]) < res_in:
#        fin_tss = (tss_list[f+1]*num_list[f+1]+tss_list[f]*num_list[f])/(num_list[f+1]+num_list[f])
#        fin_tss_list.append(fin_tss)
#        f += 2
#    else:
#        fin_tss_list.append(tss_list[f])
#        f += 1

print "tss_list created"

for e in range(len(tss_list)):
    tss_list[e] = round(tss_list[e], 3)
    stdv_list[e] = round(stdv_list[e], 3)

print "tss_list rounded"

#print tss_list
#print len(tss_list)
#print stdv_list
#print len(stdv_list)

#uncomment next 19 lines to only select TSS with lower stdv if two TSSs are within one res_in from one another
sh_tss_list = []
selsel_sum_list=[]
sh_stdv_list=[]
g = 0
while g < len(tss_list)-1:
    if (tss_list[g+1]-tss_list[g]) < int(res_in):
        if stdv_list[g+1] < stdv_list[g]:
            sh_tss_list.append(tss_list[g+1])
            selsel_sum_list.append(sel_sum_list[g+1])
            sh_stdv_list.append(stdv_list[g+1])
            g += 2
        else:
            sh_tss_list.append(tss_list[g])
            selsel_sum_list.append(sel_sum_list[g])
            sh_stdv_list.append(stdv_list[g])
            g += 2
    else:
        sh_tss_list.append(tss_list[g])
        selsel_sum_list.append(sel_sum_list[g])
        sh_stdv_list.append(stdv_list[g])
        g += 1

#print sh_tss_list
#print len(sh_tss_list)

sh_tss_file = open("sh_tss_list.txt", 'wb')
for i in sh_tss_list:
    sh_tss_file.write(str(i) + '\n')

#print selsel_sum_list
#print len(selsel_sum_list)

selsel_sum_file = open("sel_sel_sum_list.txt", 'wb')
for j in selsel_sum_list:
    selsel_sum_file.write(str(j) + '\n')

#print sh_stdv_list
#print len(sh_stdv_list)

sh_stdv_file = open("sh_stdv_list.txt", 'wb')
for k in sh_stdv_list:
    sh_stdv_file.write(str(k) + '\n')

print "program finished"